// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_object_msgs:msg/ObjectDetection.idl
// generated code does not contain a copyright notice

#ifndef TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_DETECTION__STRUCT_H_
#define TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_DETECTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'OBJECT_TYPE_PERSON'.
/**
  * object type constants
 */
static const char * const tuw_object_msgs__msg__ObjectDetection__OBJECT_TYPE_PERSON = "person";

/// Constant 'OBJECT_TYPE_OBSTACLE'.
static const char * const tuw_object_msgs__msg__ObjectDetection__OBJECT_TYPE_OBSTACLE = "obstacle";

/// Constant 'OBJECT_TYPE_TRAFFIC_CONE'.
static const char * const tuw_object_msgs__msg__ObjectDetection__OBJECT_TYPE_TRAFFIC_CONE = "traffic_cone";

/// Constant 'OBJECT_TYPE_DOOR'.
static const char * const tuw_object_msgs__msg__ObjectDetection__OBJECT_TYPE_DOOR = "door";

/// Constant 'SENSOR_TYPE_GENERIC_LASER_2D'.
/**
  * sensor type constants
 */
static const char * const tuw_object_msgs__msg__ObjectDetection__SENSOR_TYPE_GENERIC_LASER_2D = "laser2d";

/// Constant 'SENSOR_TYPE_GENERIC_LASER_3D'.
static const char * const tuw_object_msgs__msg__ObjectDetection__SENSOR_TYPE_GENERIC_LASER_3D = "laser3d";

/// Constant 'SENSOR_TYPE_GENERIC_MONOCULAR_VISION'.
static const char * const tuw_object_msgs__msg__ObjectDetection__SENSOR_TYPE_GENERIC_MONOCULAR_VISION = "mono";

/// Constant 'SENSOR_TYPE_GENERIC_STEREO_VISION'.
static const char * const tuw_object_msgs__msg__ObjectDetection__SENSOR_TYPE_GENERIC_STEREO_VISION = "stereo";

/// Constant 'SENSOR_TYPE_GENERIC_RGBD'.
static const char * const tuw_object_msgs__msg__ObjectDetection__SENSOR_TYPE_GENERIC_RGBD = "rgbd";

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'view_direction'
#include "geometry_msgs/msg/detail/quaternion__struct.h"
// Member 'type'
// Member 'sensor_type'
#include "rosidl_runtime_c/string.h"
// Member 'objects'
#include "tuw_object_msgs/msg/detail/object_with_covariance__struct.h"

/// Struct defined in msg/ObjectDetection in the package tuw_object_msgs.
/**
  * This expresses a object detection
 */
typedef struct tuw_object_msgs__msg__ObjectDetection
{
  /// timestamp in the header is the acquisition time and frame
  std_msgs__msg__Header header;
  /// distance minimum range value
  float distance_min;
  /// distance maximum range value
  float distance_max;
  /// distance maximum range value to detect id
  float distance_max_id;
  /// view direction
  geometry_msgs__msg__Quaternion view_direction;
  /// field of view horizontal
  float fov_horizontal;
  /// field of view vertical
  float fov_vertical;
  /// object type used (person, obstacle, ...)
  rosidl_runtime_c__String type;
  /// detected objects (with covariance)
  tuw_object_msgs__msg__ObjectWithCovariance__Sequence objects;
  /// Sensor / detector type, see example constants below.
  rosidl_runtime_c__String sensor_type;
} tuw_object_msgs__msg__ObjectDetection;

// Struct for a sequence of tuw_object_msgs__msg__ObjectDetection.
typedef struct tuw_object_msgs__msg__ObjectDetection__Sequence
{
  tuw_object_msgs__msg__ObjectDetection * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_object_msgs__msg__ObjectDetection__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_OBJECT_MSGS__MSG__DETAIL__OBJECT_DETECTION__STRUCT_H_
